#include <FileIO.h>
#include <Servo.h> 
Servo servox; 
Servo servoy; 

boolean donereading=false;


String dataString;
char c;
int x;
int y;
int t; // time servo delay
String s;

void setup() {
  // Initialize the Bridge and the Serial
  Bridge.begin();

  Serial.begin(57600);
  FileSystem.begin();

  //while (!Serial); // wait for Serial port to connect.
  
  Serial.println("Filesystem reader\n");
  delay(2000);  // wait 2 seconds
  
  servox.attach(A0);
  servoy.attach(A1);
  pinMode(13, OUTPUT);
}


void loop ()
{
  

  //open the file for reading:
  File myFile = FileSystem.open("/mnt/sd/datalog.txt", FILE_READ);
  
  
  if (myFile && !donereading) {
    
    // read from the file until there's nothing else in it:
            while (myFile.available()) {

                        c=myFile.read();
                        s=s+String(c);
                        
                        
                        //pharse x y t, poation x, y and the time t delay
                        //number format 180x90y29t
                       
                        if ( c=='x'){
                          s.replace("x", "");
                          x=s.toInt(); 
                          s="";
                          //Serial.print("X: ");
                          //Serial.println(x);
                        }  
                        
                        else if ( c=='y'){
                          s.replace("y", "");
                          y=s.toInt(); 
                          s="";
                          //Serial.print("Y: ");
                          //Serial.println(y);
                        }
                        else if ( c=='t'){
                          s.replace("t", "");
                          t=s.toInt(); 
                          s="";
                          //Serial.print("T: ");
                          //Serial.println(t);
                          
                          
                          Serial.print("X: ");
                          Serial.print(x);
                          Serial.print(" Y: ");
                          Serial.print(y);
                          Serial.print(" T: ");
                          Serial.println(t);
                          
                          
                          
                          // move the servo
                           //x=map(x,120,997, 90-16, 90+50 );  // (right , left ) looking at faceing device front // more +/0- more numer more movement
                           //y=map(y,88,741, 90-70, 90+10 );  // ( up , down )
                           x=map(x,120,997, 10, 170);  // (right , left ) looking at faceing device front // more +/0- more numer more movement
                           y=map(y,741,88, 10,170 );  // ( up , down )
                          
                          servox.write(x); 
                          servoy.write(y); 
                          //delayMicroseconds(t*1000);
                          digitalWrite(13, HIGH);   // turn the LED on (HIGH is the voltage level)
                          delay(t);
                          digitalWrite(13, LOW);  
                        }


                  
            }
           donereading=true;

   

   }  
  else if (donereading){
          myFile.close();
          Serial.println("END OF THE FILE");
          delay(10000);
  }
  else {
    // if the file didn't open, print an error:
    Serial.println("error opening test.txt");
  }


}

