#include <Adafruit_PS2_Trackpad.h>
#include <FileIO.h>

// PS2 uses two digital pins
#define PS2_DATA 2
#define PS2_CLK 3
//Adafruit_PS2 ps2(PS2_CLK, PS2_DATA);
// Use thid declaration when you want the trackpad to act like a 'mouse'
// with relative positioning
//Adafruit_PS2_Mouse ps2(PS2_CLK, PS2_DATA);

// Use this declaration when you want 'absolute' tablet mode
Adafruit_PS2_Trackpad ps2(PS2_CLK, PS2_DATA);

int premillis=0;
String dataString="";
String currentdata="";

void setup() {
  
  
  Bridge.begin();
  
    delay(2000);  // wait 2 seconds

  FileSystem.begin();

  delay(2000);  // wait 2 seconds

  while (!Serial); // wait for Serial port to connect.
  //Serial.println("Filesystem datalogger\n");
  

  

  Serial.begin(57600);
      Serial.println("go");

  
    while (!ps2.begin()){
        Serial.println("Did not find PS2 mouse device");
        delay (100);
      }
      Serial.println("Successfully found PS2 mouse device");
      //Serial.print("PS/2 Mouse with ID 0x");
      //Serial.println(ps2.readID(), HEX);


  pinMode(13, OUTPUT);
  digitalWrite(13, HIGH);

}

uint16_t lasttap_x = 0, lasttap_y = 0;

void loop() {


  if (! ps2.readData()){  return;}
  
  
  
  //Serial.print("0x");
  //Serial.print(ps2.status, HEX); Serial.print("\t");
 
  //Serial.print("X = "); Serial.print(ps2.x, DEC); 
  //Serial.print("Y = "); Serial.print(ps2.y, DEC); 
  //Serial.print("Z = "); Serial.print(ps2.z); 
  
  /*
  if (ps2.finger) Serial.print("\tFinger");
  if (ps2.right) Serial.print("\tRight");
  if (ps2.middle) Serial.print("\tMiddle");
  if (ps2.left) Serial.print("\tLeft");
  
  if (ps2.gesture && !ps2.finger)  {
    if ((lasttap_x == ps2.x) && (lasttap_y == ps2.y)) {
      Serial.print("\tDouble tap!");
    } else {
      Serial.print("\tTap");
    }
    lasttap_x = ps2.x;
    lasttap_y = ps2.y;
  }
  Serial.println();
  
 */
 
    //number format 180x90y29t
    currentdata=String(ps2.x, DEC) +"x"+ String(ps2.y, DEC) +"y"+ String(getTimeStamp())+"t";
    //dataString =  dataString + currentdata;    // separate the values with a comma
  
  
  
   File dataFile = FileSystem.open("/mnt/sd/datalog.txt", FILE_APPEND);
  // if the file is available, write to it:
  if (dataFile) {
    //dataFile.println(dataString);
    dataFile.print(currentdata);
    dataFile.close();
    // print to the serial port too:
    //Serial.println(dataString);
    Serial.println(currentdata);
    
  }
  // if the file isn't open, pop up an error:
  else {
    Serial.println("error opening datalog.txt");
  }
 
 
 
 
  delay(25);
}







String getTimeStamp() {

  //String result;
  //Process time;
  /*
  // date is a command line utility to get the date and the time
  // in different formats depending on the additional parameter
  time.begin("date");
  time.addParameter("+%D-%T");  // parameters: D for the complete date mm/dd/yy
  //             T for the time hh:mm:ss
  time.run();  // run the command

  // read the output of the command
  while (time.available() > 0) {
    char c = time.read();
    if (c != '\n')
      result += c;
  }
*/
  int cmillis=millis();
  String result= String(cmillis-premillis);
  premillis=cmillis;

  return result;
}
